"use strict";

function NSGetModule(compMgr, fileSpec) { return MenuManipulatorModule; }
function NSGetFactory() { return Factory; }

var MenuManipulatorModule = {
 CID: Components.ID("{4381b0c0-a68e-11d9-9669-0800200c9a66}"),
 contractID: "@dorando.at/menumanipulator;1",
 className: "MenuManipulatorService",

 registerSelf: function (aComponentManager, aFileSpec, aLocation, aType) {
  aComponentManager = aComponentManager.QueryInterface(Components.interfaces.nsIComponentRegistrar);

  aComponentManager.registerFactoryLocation(this.CID, this.className, this.contractID, aFileSpec, aLocation, aType);

  var CategoryManager = Components.classes["@mozilla.org/categorymanager;1"]
                                  .getService(Components.interfaces.nsICategoryManager);
  CategoryManager.addCategoryEntry("app-startup", this.className, "service," + this.contractID, true, true, null);
 },
  
 getClassObject: function (aComponentManager, aCID, aIID) {
  if (!aIID.equals(Components.interfaces.nsIFactory)) throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

  if (aCID.equals(this.CID)) return Factory;
    
  throw Components.results.NS_ERROR_NO_INTERFACE;
 },

 canUnload: function () { return true; }
};

var Factory = {
 createInstance: function (aOuter, aIID)
 {
  if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION;

  return new MenuManipulatorService();
 }
};

var document, node;

function MenuManipulatorService() {
 Components.utils.import("resource://gre/modules/Services.jsm");
 Services.obs.addObserver(this, "final-ui-startup", false);
}
MenuManipulatorService.prototype = {
 observe: function (aSubject, aTopic, aData) {
  switch(aTopic) {
   case "profile-after-change":
    break;
   case "final-ui-startup":
    Services.obs.removeObserver(this, "final-ui-startup");
    this.ps = Services.prefs.getBranch("menumanipulator.");
    Services.obs.addObserver(this, this.ps.getCharPref("observe"), false);
    break;
   default:
    aSubject.menumanipulator = this;
    aSubject.addEventListener("load",this.load,true);
  }
 },

 load: function(event) {
  this.removeEventListener("load",this.menumanipulator.load,true);

  if(event.target instanceof Components.interfaces.nsIDOMXULDocument)
   this.addEventListener(event.eventPhase == 2 ? "pageshow" : "load",this.menumanipulator.init,false);
 },

 init: function(event) {
  if(event && event.eventPhase != 2) return;

  this.removeEventListener("pageshow",this.menumanipulator.init,false);

  document = this.document;

  var code = this.menumanipulator.ps.getComplexValue("global.20140526", Components.interfaces.nsISupportsString).data;

  if(this.menumanipulator.ps.prefHasUserValue(this.document.location))
   code += this.menumanipulator.ps.getComplexValue(this.document.location,Components.interfaces.nsISupportsString).data;

  eval(code);

  document = null;
  node = null;
 }
}

function SetID() {
 ID("//x:menuseparator[not(@id)] | id('menumanipulator-tabcontext')/x:menuseparator[not(@id)]", "separator");
 ID("//x:menu[not(@id)]/x:menupopup[not(@id)] | id('menumanipulator-tabcontext')/x:menupopup[not(@id)]", "popup");
}

function SetTab() {
 try {
  var gBrowser = document.defaultView.gBrowser;
  var tabContext = gBrowser.tabContextMenu || document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabContextMenu");
  if(!tabContext.id) tabContext.id = "menumanipulator-tabcontext";
 } catch(err){ }
}

function Module(module) { try { 
 Services.scriptloader.loadSubScript("chrome://menumanipulator/content/" + module + ".js", null, "UTF-8");
} catch(err){ Components.utils.reportError(err); } }

function Load(path) { try { 
 Services.scriptloader.loadSubScript(path, null, "UTF-8");
} catch(err){ Components.utils.reportError(err); } }

function NSResolver() { return "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" }

function Nodes(path, type) { return document.evaluate(path, document, NSResolver, type, null); }

function Node(path) {
 node = Nodes(path,8).singleNodeValue;
 if(node)
  node.menumanipulator = {path: path, set: new Object()};
}

function Set(attr, value) {
 if(node) {
  node.menumanipulator.set[attr] = value;
  node.setAttribute(attr, value);
 }
}

function Move(path, index, fallbacks) {
 var relNode = Nodes(path,8).singleNodeValue;

 if(node) if(relNode) {
  node.menumanipulator.moved = true;
  if(index == -1)
   relNode.parentNode.insertBefore(node, relNode);
  else if(index == -2) {
   relNode.appendChild(node);
  } else {
   relNode.insertBefore(node,relNode.children[index]);
  }
 } else {
  if(fallbacks && fallbacks.length) Move(fallbacks.shift(), fallbacks.shift(), fallbacks);
 }
}

function New(type, id) {
 node = document.createElement(type);
 if(id) node.id = id;
 node.menumanipulator = {path: "id('"+id+"')", set: new Object(), created: true};
}

function ID(path, name) {
 var nodes = Nodes(path, 7);

 var i;
 for(i = 0; i < nodes.snapshotLength; i++)
  nodes.snapshotItem(i).id = "menumanipulator-" + name + "-" + i;
}
